<id>
IP Banning
</id>

<version>
1.1
</version>


<mod info>
This mod making clickable IP in Posts for banning and unbanning.
Admin and Gmod ban IP in display messages.

After install mod need go to AdminCenter and enable for GMod function [ipban] and [ipban3]
</mod info>


<author>
Boris Tjuvanov (MF-B) and Jeffrey Man (Jet Li)
</author>


<homepage>
http://yabb.xost.ru and http://www.grafix-world.nl
</homepage>




<edit file>
Sources/Display.pl
</edit file>


<search for>
		$outblock =~ s/<yabb ip>/$mip/g;
</search for>

<replace>
 		$outblock =~ s/<yabb ip>/$miplink/g;
</replace>


<search for>
		if ($iamadmin || $iamgmod && $gmod_access2{'ipban2'} eq "on") { $mip = $mip }
		else { $mip = "$display_txt{'511'}"; }
		$sendm = '';

		# If the user isn't a guest, load their info.
		if ($musername ne 'Guest' && !$yyUDLoaded{$musername} && -e ("$memberdir/$musername.vars")) {
			&LoadUserDisplay($musername);
		}
</search for>

<replace>
		# If the user isn't a guest, load their info.
		if ($musername ne 'Guest' && !$yyUDLoaded{$musername} && -e ("$memberdir/$musername.vars")) {
			&LoadUserDisplay($musername);
		}

		$miplink = '';
		if ($iamadmin || $iamgmod && $gmod_access2{'ipban2'} eq "on" && $gmod_access2{'ipban3'} eq "on") {
			if (${$uid.$musername}{'position'} ne "Administrator" && ${$uid.$musername}{'position'} ne "Global Moderator") {
				(@mips) = split(/\ /, $mip);
				foreach $mipvalue (@mips) {
					chomp $mipvalue;
					if (&check_banlist($mipvalue)) { $miplink .= qq~<a href="$adminurl?action=ipban3;ban=$mipvalue;unban=1;return1=num;return2=$viewnum/$counter#$counter" onclick="return confirm('$maintxt{'ip_unban'}');" style="color: red;"><span class="small">$mipvalue</span></a> ~; } 
					else { $miplink .= qq~<a href="$adminurl?action=ipban3;ban=$mipvalue;return1=num;return2=$viewnum/$counter#$counter" onclick="return confirm('$maintxt{'ip_ban'}');" style="color: green;"><span class="small">$mipvalue</span></a> ~; }
				}
			} else {
				(@mips) = split(/\ /, $mip);
				foreach $mipvalue (@mips) {
					chomp $mipvalue;
					if (&check_banlist($mipvalue)) { $miplink .= qq~<span class="small"><span style="color: red;">$mipvalue</span></span> ~; }
					else { $miplink .= qq~<span class="small"><span style="color: green;">$mipvalue</span></span> ~; }
				}
			}
		} else { $miplink = "$display_txt{'511'}"; }
		$sendm = '';
</replace>






<edit file>
Sources/Security.pl
</edit file>


<search for>
sub banning {
</search for>

<add before>
sub check_banlist {

	my ($ip_ban) = $_[0];
	$ban_rtn = '';

	my $bansize = -s "$vardir/ban.txt";
	if ($bansize > 9) {
		fopen(BAN, "$vardir/ban.txt");
		@banlist = <BAN>;
		fclose(BAN);
	} else {
		return 0;
	}
	
	foreach my $line (@banlist) {
		@banned = ();
		chomp $line;
		my ($bantype, $bannedlst) = split(/\|/, $line);
		if ($bantype eq "I") {
			@banned = split(/\,/, $bannedlst);
			foreach my $ipbanned (@banned) {
				chomp $ipbanned;
				if ($ipbanned eq $ip_ban) { $ban_rtn = 'I'; }
			}
		}
	}
	return $ban_rtn;
}


</add before>


<search for>
$scripturl = qq~$boardurl/YaBB.$yyext~;
</search for>

<add after>
$adminfile = (-e "$boarddir/nph-AdminIndex.$yyaext") ? "nph-AdminIndex" : "AdminIndex";
$adminurl = "$boardurl/$adminfile.$yyaext";
</add after>






<edit file>
Admin/Admin.pl
</edit file>


<search for>
sub ver_detail {
</search for>

<add before>
sub ipban_update {

	&is_admin_or_gmod;

	$ban_ip = $INFO{'ban'};

	fopen(BAN, "$vardir/ban.txt");
	@banlist = <BAN>;
	$lines = @banlist;
	fclose(BAN);

	if ($INFO{'unban'} eq 1) {

		$i = 0;
		foreach $banned (@banlist) {
			chomp @banlist;
			($dummy[$i], $bansett[$i]) = split(/\|/, $banlist[$i]);
			if ($dummy[$i] eq "I") {
				(@banlist2) = split(/\,/, $bansett[$i]);
				foreach $banned2 (@banlist2) {
					chomp $banned2;
					if ($banned2 eq $ban_ip) { $banned2 = ""; } 
					else { $banned2 = "$banned2,"; }
					$banned3 .= $banned2;
				}
				$banned3 =~ s/\,\,/\,/g;
				$bannewline = "I|$banned3\n"; 
			} 
			elsif ($dummy[$i] eq "E") { $bannewline = "E|$bansett[$i]\n"; }
			elsif ($dummy[$i] eq "U") { $bannewline = "U|$bansett[$i]\n"; }
			push(@allbans, $bannewline);
			$i++;
		}
	
	} else {
		foreach my $banned (@banlist) {
			($dummy, $bansett) = split(/\|/, $banned);
			chomp $dummy;
			chomp $bansett;
			if ($dummy eq "I") { $bannewline = "$dummy|$bansett,$ban_ip\n"; $bannewline =~ s/\,\,/\,/g; }
			elsif ($dummy eq "E") { $bannewline = "$dummy|$bansett\n"; }
			elsif ($dummy eq "U") { $bannewline = "$dummy|$bansett\n"; }
			else { $bannewline = "I|$ban_ip\n"; }
			push(@allbans, $bannewline);
		}
	}
	
	if (!$lines) { $bannewline = "I|$ban_ip\n"; push(@allbans, $bannewline); }

	fopen(BANFILE, ">$vardir/ban.txt", 1);
		seek BANFILE, 0, 0;
		truncate BANFILE, 0;
		print BANFILE @allbans;
	fclose(BANFILE);

	$yySetLocation = qq~$scripturl?$INFO{'return1'}=$INFO{'return2'}~;
	&redirectexit;

}


</add before>








<edit file>
Admin/AdminSubList.pl
</edit file>


<search for>
%director=(
</search for>

<add after>
'ipban3',"Admin.pl&ipban_update",
</add after>








<edit file>
Admin/AdminEdit.pl
</edit file>


<search for>
ipban2 => "$FORM{'ipban'}",
</search for>

<add after>
ipban3 => "$FORM{'ipban3'}",
</add after>


<search for>
'ipban',"$FORM{'ipban'}",
</search for>

<add after>
'ipban3',"$FORM{'ipban3'}",
</add after>






<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$ip_banmod = "IP Banning 1.1|Boris Tjuvanov (<a href=\"http://yabb.xost.ru\" target=\"_blank\">MF-B</a>) and Jeffrey Man (<a href=\"http://www.grafix-world.nl\" target=\"_blank\">Jet Li</a>)|This mod making clickable IP in Posts for banning and unbanning.|1.1|02.06.2007";
	push (@installed_mods, "$ip_banmod");
</add before>






<edit file>
Languages/English/Main.lng
</edit file>


<search for>
'dst' => "<sup>*</sup>",
</search for>

<add after>
'ip_ban' => "Are you sure you want to ban this IP?",
'ip_unban' => "Are you sure you want to unban this IP?",
</add after>

